(function(){"use strict";try{if(typeof document!="undefined"){var e=document.createElement("style");e.appendChild(document.createTextNode(".mk-input{min-height:1.4em}.mk-input span{outline:none;white-space:pre-wrap}.mk-suggestions{border:1px solid #ccc;max-height:186px;overflow-y:auto;padding-left:0;position:absolute;background:white;width:fit-content;min-width:100px;margin-top:0;margin-bottom:0;transition:1.1s ease-out;filter:blur(0);transform:scale(1);opacity:1;visibility:visible;color:#000;border-radius:4%;box-shadow:0 3px 6px -2px #0009}.mk-suggestions li{padding:.5rem}.mk-suggestions li:hover,.mk-suggestion-active{background-color:#cce9ff;color:#2589f5;cursor:pointer}")),document.head.appendChild(e)}}catch(i){console.error("vite-plugin-css-injected-by-js",i)}})();
var ar = Object.defineProperty;
var sr = (n, e, t) => e in n ? ar(n, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : n[e] = t;
var P = (n, e, t) => (sr(n, typeof e != "symbol" ? e + "" : e, t), t), Se = (n, e, t) => {
  if (!e.has(n))
    throw TypeError("Cannot " + t);
};
var V = (n, e, t) => (Se(n, e, "read from private field"), t ? t.call(n) : e.get(n)), Q = (n, e, t) => {
  if (e.has(n))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(n) : e.set(n, t);
}, ke = (n, e, t, r) => (Se(n, e, "write to private field"), r ? r.call(n, t) : e.set(n, t), t);
var le = (n, e, t) => (Se(n, e, "access private method"), t);
import Te, { useContext as or, Children as ur, isValidElement as st, useEffect as I, useState as re, useRef as ne, useLayoutEffect as lr, useCallback as X, memo as mt, useMemo as Oe, forwardRef as cr, createRef as ot } from "react";
class ce {
  constructor(e, t, r, a) {
    this.data = e, this.prev = t, this.next = r, this.list = a;
  }
  get index() {
    if (!!this.list)
      return this.list.findIndex((e) => e === this.data);
  }
  insertBefore(e) {
    return this.list !== null ? this.list.insertBefore(this, e) : new $(e, this.data);
  }
  insertAfter(e) {
    return this.list !== null ? this.list.insertAfter(this, e) : new $(this.data, e);
  }
  remove() {
    if (this.list === null)
      throw new ReferenceError("Node does not belong to any list");
    return this.list.removeNode(this);
  }
}
class $ {
  constructor(...e) {
    P(this, "head");
    P(this, "tail");
    P(this, "size");
    this.head = null, this.tail = null, this.size = 0;
    for (let t = 0; t < arguments.length; t++)
      this.append(arguments[t]);
  }
  get length() {
    return this.size;
  }
  static from(e) {
    return new $(...e);
  }
  get(e) {
    const t = this.getNode(e);
    return t !== void 0 ? t.data : void 0;
  }
  getNode(e) {
    if (this.head === null || e < 0 || e >= this.length)
      return;
    const t = e < this.length / 2, r = t ? e : this.length - e - 1, a = t ? "next" : "prev";
    let s = t ? this.head : this.tail;
    for (let u = 0; u < r; u++)
      s = s[a];
    return s;
  }
  findNodeIndex(e) {
    let t = 0, r = this.head;
    for (; r; ) {
      if (e(r.data, t, this))
        return {
          index: t,
          node: r
        };
      r = r.next, t += 1;
    }
  }
  findNode(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.node : void 0;
  }
  find(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.node.data : void 0;
  }
  findIndex(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.index : -1;
  }
  append(...e) {
    for (const t of e) {
      const r = new ce(t, this.tail, null, this);
      this.head === null && (this.head = r), this.tail !== null && (this.tail.next = r), this.tail = r, this.size += 1;
    }
    return this;
  }
  prepend(...e) {
    const t = Array.from(e).reverse();
    for (const r of t) {
      const a = new ce(r, null, this.head, this);
      this.tail === null && (this.tail = a), this.head !== null && (this.head.prev = a), this.head = a, this.size += 1;
    }
    return this;
  }
  insertAt(e, t) {
    if (this.head === null)
      return this.append(t);
    if (e <= 0)
      return this.prepend(t);
    let r = this.head, a = 0;
    for (; a < e - 1 && r.next !== null; )
      a += 1, r = r.next;
    return r.insertAfter(t), this;
  }
  removeNode(e) {
    if (e.list !== this)
      throw new ReferenceError("Node does not belong to this list");
    return e.prev !== null && (e.prev.next = e.next), e.next !== null && (e.next.prev = e.prev), this.head === e && (this.head = e.next), this.tail === e && (this.tail = e.prev), this.size -= 1, e.next = null, e.prev = null, e.list = null, e;
  }
  removeAt(e) {
    const t = this.getNode(e);
    return t !== void 0 ? this.removeNode(t) : void 0;
  }
  insertBefore(e, t) {
    const r = new ce(t, e.prev, e, this);
    return e.prev === null && (this.head = r), e.prev !== null && (e.prev.next = r), e.prev = r, this.size += 1, this;
  }
  sort(e) {
    if (this.head === null || this.tail === null)
      return this;
    if (this.length < 2)
      return this;
    const t = (r, a) => {
      if (r === a)
        return;
      const s = a.data;
      let u = r, l = r;
      for (; u && u !== a; ) {
        if (e(u.data, s)) {
          if (u !== l) {
            const h = l.data;
            l.data = u.data, u.data = h;
          }
          l = l.next;
        }
        u = u.next;
      }
      a.data = l.data, l.data = s, r.next !== a.prev && (l.prev && l !== r && t(r, l.prev), l.next && l !== a && t(l.next, a));
    };
    return t(this.head, this.tail), this;
  }
  insertAfter(e, t) {
    const r = new ce(t, e, e.next, this);
    return e.next === null && (this.tail = r), e.next !== null && (e.next.prev = r), e.next = r, this.size += 1, this;
  }
  shift() {
    return this.removeFromAnyEnd(this.head);
  }
  pop() {
    return this.removeFromAnyEnd(this.tail);
  }
  merge(e) {
    this.tail !== null && (this.tail.next = e.head), e.head !== null && (e.head.prev = this.tail), this.head = this.head || e.head, this.tail = e.tail || this.tail, this.size += e.size, e.size = this.size, e.head = this.head, e.tail = this.tail;
  }
  clear() {
    return this.head = null, this.tail = null, this.size = 0, this;
  }
  slice(e, t) {
    const r = new $();
    let a = t;
    if (this.head === null || this.tail === null)
      return r;
    (a === void 0 || a < e) && (a = this.length);
    let s = this.getNode(e);
    for (let u = 0; u < a - e && s !== null && s !== void 0; u++)
      r.append(s.data), s = s.next;
    return r;
  }
  reverse() {
    let e = this.head;
    for (; e; ) {
      const r = e.next;
      e.next = e.prev, e.prev = r, e = e.prev;
    }
    const t = this.tail;
    return this.tail = this.head, this.head = t, this;
  }
  forEach(e, t = !1) {
    let r = t ? this.length - 1 : 0, a = t ? this.tail : this.head;
    const s = t ? -1 : 1, u = t ? "prev" : "next";
    for (; a; )
      e(a.data, r, this), a = a[u], r += s;
  }
  map(e, t = !1) {
    const r = new $();
    return this.forEach((a, s) => r.append(e(a, s, this)), t), r;
  }
  filter(e, t = !1) {
    const r = new $();
    return this.forEach((a, s) => {
      e(a, s, this) && r.append(a);
    }, t), r;
  }
  reduce(e, t, r = !1) {
    let a = r ? this.length - 1 : 0;
    const s = r ? -1 : 1, u = r ? "prev" : "next";
    let l = r ? this.tail : this.head, c;
    if (t !== void 0)
      c = t;
    else if (l)
      c = l.data, l = l[u];
    else
      throw new TypeError("Reduce of empty LinkedList with no initial value");
    for (; l; )
      c = e(c, l.data, a, this), a += s, l = l[u];
    return c;
  }
  toArray() {
    return [...this];
  }
  toString(e = " ") {
    return this.reduce((t, r) => `${t}${e}${r}`);
  }
  *[Symbol.iterator]() {
    let e = this.head;
    for (; e !== null; )
      yield e.data, e = e.next;
  }
  removeFromAnyEnd(e) {
    return e !== null ? this.removeNode(e).data : void 0;
  }
}
var W = /* @__PURE__ */ ((n) => (n.UP = "ArrowUp", n.DOWN = "ArrowDown", n.LEFT = "ArrowLeft", n.RIGHT = "ArrowRight", n.END = "End", n.HOME = "Home", n.PAGE_DOWN = "PageDown", n.PAGE_UP = "PageUp", n.ENTER = "Enter", n.TAB = "Tab", n.SPACE = " ", n.BACKSPACE = "Backspace", n.DELETE = "Delete", n.COMMA = ",", n.ESC = "Escape", n))(W || {}), F = /* @__PURE__ */ ((n) => (n.LABEL = "__label__", n.VALUE = "__value__", n))(F || {});
const ut = "mk-input", lt = {
  trigger: "@",
  markup: "@[__label__](__value__)",
  data: [],
  index: 0
}, fr = [
  "onFocus",
  "onBlur",
  "onKeyDown",
  "onClick",
  "onMouseDown",
  "onMouseMove",
  "onMouseUp",
  "onMouseOver",
  "onMouseLeave"
], dr = new RegExp(/^\w*/), hr = $.from([]);
class vr {
  constructor(e, t) {
    P(this, "done", !1);
    this.raw = e, this.uniRegExp = t;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let e = this.uniRegExp.exec(this.raw);
    if (e === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [t, r, a] = this.extractPieces(e);
    return this.raw = a, { done: !1, value: [t, r] };
  }
  extractPieces(e) {
    const t = this.extractMark(e), r = t.input.substring(0, t.index), a = t.input.substring(t.index + t.annotation.length);
    return [r, t, a];
  }
  extractMark(e) {
    let t = e[0], r = 0, a = e[1], s = e[2];
    for (; !(a || s); )
      r++, a = e[2 * r + 1], s = e[2 * r + 2];
    let u = e.index, l = e.input;
    return { annotation: t, label: a, value: s, input: l, index: u, childIndex: r };
  }
}
class ve {
  constructor(e) {
    P(this, "markups");
    P(this, "uniRegExp");
    this.markups = e, this.uniRegExp = new RegExp(this.regExps.map((t) => t.source).join("|"));
  }
  get regExps() {
    return this.markups.map(pr);
  }
  static split(e, t) {
    const r = t.map((a) => a.markup);
    return () => new ve(r).split(e);
  }
  split(e) {
    return this.iterateMatches(e);
  }
  iterateMatches(e) {
    const t = [];
    for (let [r, a] of new vr(e, this.uniRegExp))
      t.push(r), a !== null && t.push(gr(a, this.markups[a.childIndex]));
    return t;
  }
}
const yt = Object.assign, pr = (n) => {
  var s, u;
  const e = fe(n), t = fe((s = n[n.indexOf(F.LABEL) + F.LABEL.length]) != null ? s : ""), r = fe((u = n[n.indexOf(F.VALUE) + F.VALUE.length]) != null ? u : ""), a = e.replace(F.LABEL, `([^${t}]+?)`).replace(F.VALUE, `([^${r}]+?)`);
  return new RegExp(a);
}, gr = (n, e) => n.annotation !== Ne(e, n.label, n.value) ? { ...n, label: n.value, value: n.label } : n, fe = (n) => n.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function Ne(n, e, t) {
  let r = n.replace(F.LABEL, e);
  return t ? r.replace(F.VALUE, t) : r;
}
function tn(n, e, ...t) {
  return t.length ? new ve(t).split(n).reduce((a, s) => a += pe(s) ? e(s) : s, "") : n;
}
function ct(n, e) {
  let t = "";
  for (let r of n)
    t += Et(r) ? Ne(e[r.childIndex].markup, r.label, r.value) : r.label;
  return t;
}
const ft = (n, e = 0) => {
  let t = 3735928559 ^ e, r = 1103547991 ^ e;
  for (let a = 0, s; a < n.length; a++)
    s = n.charCodeAt(a), t = Math.imul(t ^ s, 2654435761), r = Math.imul(r ^ s, 1597334677);
  return t = Math.imul(t ^ t >>> 16, 2246822507) ^ Math.imul(r ^ r >>> 13, 3266489909), r = Math.imul(r ^ r >>> 16, 2246822507) ^ Math.imul(t ^ t >>> 13, 3266489909), 4294967296 * (2097151 & r) + (t >>> 0);
}, pe = (n) => typeof n == "object", Et = (n) => n !== null && typeof n == "object" && "annotation" in n;
function mr(n) {
  if (!(n !== null && typeof n == "object" && "annotation" in n))
    throw new Error("Value is not annotated mark!");
}
const dt = (n) => typeof n == "string" && n.startsWith("on"), yr = (n) => st(n) ? !0 : st(n == null ? void 0 : n[0]);
function xt(n) {
  if (yr(n))
    return ur.map(n, (t, r) => e(t.props, r));
  if (n != null && n.length)
    return n.map(e);
  return [lt];
  function e(t, r) {
    return yt({}, lt, t, { index: r });
  }
}
const wt = (n) => {
  const e = Te.createContext(void 0);
  e.displayName = n;
  const t = a(e), r = e.Provider;
  return [t, r];
  function a(s) {
    return () => {
      const u = or(s);
      if (u)
        return u;
      throw new Error(`The context ${s.displayName} didn't found!`);
    };
  }
}, [R, Er] = wt("StoreProvider"), [bt, xr] = wt("NodeProvider");
function wr(n, e, t, r) {
  return n.slice(0, t) + e + n.slice(t + r.length);
}
function br(n, e) {
  const t = pe(n) ? n.label + n.value : n;
  let r = 0, a = ft(t, r);
  for (; e != null && e.has(a); )
    a = ft(t, r++);
  return e == null || e.add(a), a;
}
const Cr = (n) => n && "$$typeof" in n && n.$$typeof === Symbol.for("react.forward_ref");
var b = /* @__PURE__ */ ((n) => (n[n.Change = 0] = "Change", n[n.Delete = 1] = "Delete", n[n.CheckTrigger = 2] = "CheckTrigger", n[n.ClearTrigger = 3] = "ClearTrigger", n[n.Trigger = 4] = "Trigger", n[n.Select = 5] = "Select", n[n.State = 6] = "State", n))(b || {});
function O(n, e, t, r) {
  const {
    bus: a
  } = r != null ? r : R();
  I(() => a.listen(n, e), t);
}
function Rr(n, e) {
  if (Object.is(n, e))
    return !0;
  if (typeof n != "object" || n === null || typeof e != "object" || e === null)
    return !1;
  const t = Object.keys(n);
  if (t.length !== Object.keys(e).length)
    return !1;
  for (let r = 0; r < t.length; r++)
    if (!Object.prototype.hasOwnProperty.call(e, t[r]) || !Object.is(n[t[r]], e[t[r]]))
      return !1;
  return !0;
}
const j = (n, e) => {
  const t = R(), [r, a] = re(() => n(t.state));
  return O(b.State, (s) => {
    a((u) => {
      const l = n(s);
      return e && Rr(u, l) ? u : l;
    });
  }, []), r;
};
var Ae = { exports: {} }, ee = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var ht;
function Sr() {
  if (ht)
    return ee;
  ht = 1;
  var n = Te, e = Symbol.for("react.element"), t = Symbol.for("react.fragment"), r = Object.prototype.hasOwnProperty, a = n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, s = { key: !0, ref: !0, __self: !0, __source: !0 };
  function u(l, c, h) {
    var g, E = {}, C = null, S = null;
    h !== void 0 && (C = "" + h), c.key !== void 0 && (C = "" + c.key), c.ref !== void 0 && (S = c.ref);
    for (g in c)
      r.call(c, g) && !s.hasOwnProperty(g) && (E[g] = c[g]);
    if (l && l.defaultProps)
      for (g in c = l.defaultProps, c)
        E[g] === void 0 && (E[g] = c[g]);
    return { $$typeof: e, type: l, key: C, ref: S, props: E, _owner: a.current };
  }
  return ee.Fragment = t, ee.jsx = u, ee.jsxs = u, ee;
}
var te = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var vt;
function kr() {
  return vt || (vt = 1, process.env.NODE_ENV !== "production" && function() {
    var n = Te, e = Symbol.for("react.element"), t = Symbol.for("react.portal"), r = Symbol.for("react.fragment"), a = Symbol.for("react.strict_mode"), s = Symbol.for("react.profiler"), u = Symbol.for("react.provider"), l = Symbol.for("react.context"), c = Symbol.for("react.forward_ref"), h = Symbol.for("react.suspense"), g = Symbol.for("react.suspense_list"), E = Symbol.for("react.memo"), C = Symbol.for("react.lazy"), S = Symbol.for("react.offscreen"), N = Symbol.iterator, ge = "@@iterator";
    function St(i) {
      if (i === null || typeof i != "object")
        return null;
      var o = N && i[N] || i[ge];
      return typeof o == "function" ? o : null;
    }
    var G = n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function k(i) {
      {
        for (var o = arguments.length, f = new Array(o > 1 ? o - 1 : 0), d = 1; d < o; d++)
          f[d - 1] = arguments[d];
        kt("error", i, f);
      }
    }
    function kt(i, o, f) {
      {
        var d = G.ReactDebugCurrentFrame, m = d.getStackAddendum();
        m !== "" && (o += "%s", f = f.concat([m]));
        var y = f.map(function(p) {
          return String(p);
        });
        y.unshift("Warning: " + o), Function.prototype.apply.call(console[i], console, y);
      }
    }
    var _t = !1, Pt = !1, Tt = !1, Ot = !1, Nt = !1, Le;
    Le = Symbol.for("react.module.reference");
    function At(i) {
      return !!(typeof i == "string" || typeof i == "function" || i === r || i === s || Nt || i === a || i === h || i === g || Ot || i === S || _t || Pt || Tt || typeof i == "object" && i !== null && (i.$$typeof === C || i.$$typeof === E || i.$$typeof === u || i.$$typeof === l || i.$$typeof === c || i.$$typeof === Le || i.getModuleId !== void 0));
    }
    function Dt(i, o, f) {
      var d = i.displayName;
      if (d)
        return d;
      var m = o.displayName || o.name || "";
      return m !== "" ? f + "(" + m + ")" : f;
    }
    function Me(i) {
      return i.displayName || "Context";
    }
    function L(i) {
      if (i == null)
        return null;
      if (typeof i.tag == "number" && k("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof i == "function")
        return i.displayName || i.name || null;
      if (typeof i == "string")
        return i;
      switch (i) {
        case r:
          return "Fragment";
        case t:
          return "Portal";
        case s:
          return "Profiler";
        case a:
          return "StrictMode";
        case h:
          return "Suspense";
        case g:
          return "SuspenseList";
      }
      if (typeof i == "object")
        switch (i.$$typeof) {
          case l:
            var o = i;
            return Me(o) + ".Consumer";
          case u:
            var f = i;
            return Me(f._context) + ".Provider";
          case c:
            return Dt(i, i.render, "ForwardRef");
          case E:
            var d = i.displayName || null;
            return d !== null ? d : L(i.type) || "Memo";
          case C: {
            var m = i, y = m._payload, p = m._init;
            try {
              return L(p(y));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var B = Object.assign, Z = 0, Fe, $e, We, Ve, Ue, Be, ze;
    function Ge() {
    }
    Ge.__reactDisabledLog = !0;
    function It() {
      {
        if (Z === 0) {
          Fe = console.log, $e = console.info, We = console.warn, Ve = console.error, Ue = console.group, Be = console.groupCollapsed, ze = console.groupEnd;
          var i = {
            configurable: !0,
            enumerable: !0,
            value: Ge,
            writable: !0
          };
          Object.defineProperties(console, {
            info: i,
            log: i,
            warn: i,
            error: i,
            group: i,
            groupCollapsed: i,
            groupEnd: i
          });
        }
        Z++;
      }
    }
    function jt() {
      {
        if (Z--, Z === 0) {
          var i = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: B({}, i, {
              value: Fe
            }),
            info: B({}, i, {
              value: $e
            }),
            warn: B({}, i, {
              value: We
            }),
            error: B({}, i, {
              value: Ve
            }),
            group: B({}, i, {
              value: Ue
            }),
            groupCollapsed: B({}, i, {
              value: Be
            }),
            groupEnd: B({}, i, {
              value: ze
            })
          });
        }
        Z < 0 && k("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var me = G.ReactCurrentDispatcher, ye;
    function ie(i, o, f) {
      {
        if (ye === void 0)
          try {
            throw Error();
          } catch (m) {
            var d = m.stack.trim().match(/\n( *(at )?)/);
            ye = d && d[1] || "";
          }
        return `
` + ye + i;
      }
    }
    var Ee = !1, ae;
    {
      var Lt = typeof WeakMap == "function" ? WeakMap : Map;
      ae = new Lt();
    }
    function He(i, o) {
      if (!i || Ee)
        return "";
      {
        var f = ae.get(i);
        if (f !== void 0)
          return f;
      }
      var d;
      Ee = !0;
      var m = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var y;
      y = me.current, me.current = null, It();
      try {
        if (o) {
          var p = function() {
            throw Error();
          };
          if (Object.defineProperty(p.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(p, []);
            } catch (M) {
              d = M;
            }
            Reflect.construct(i, [], p);
          } else {
            try {
              p.call();
            } catch (M) {
              d = M;
            }
            i.call(p.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (M) {
            d = M;
          }
          i();
        }
      } catch (M) {
        if (M && d && typeof M.stack == "string") {
          for (var v = M.stack.split(`
`), _ = d.stack.split(`
`), x = v.length - 1, w = _.length - 1; x >= 1 && w >= 0 && v[x] !== _[w]; )
            w--;
          for (; x >= 1 && w >= 0; x--, w--)
            if (v[x] !== _[w]) {
              if (x !== 1 || w !== 1)
                do
                  if (x--, w--, w < 0 || v[x] !== _[w]) {
                    var A = `
` + v[x].replace(" at new ", " at ");
                    return i.displayName && A.includes("<anonymous>") && (A = A.replace("<anonymous>", i.displayName)), typeof i == "function" && ae.set(i, A), A;
                  }
                while (x >= 1 && w >= 0);
              break;
            }
        }
      } finally {
        Ee = !1, me.current = y, jt(), Error.prepareStackTrace = m;
      }
      var q = i ? i.displayName || i.name : "", at = q ? ie(q) : "";
      return typeof i == "function" && ae.set(i, at), at;
    }
    function Mt(i, o, f) {
      return He(i, !1);
    }
    function Ft(i) {
      var o = i.prototype;
      return !!(o && o.isReactComponent);
    }
    function se(i, o, f) {
      if (i == null)
        return "";
      if (typeof i == "function")
        return He(i, Ft(i));
      if (typeof i == "string")
        return ie(i);
      switch (i) {
        case h:
          return ie("Suspense");
        case g:
          return ie("SuspenseList");
      }
      if (typeof i == "object")
        switch (i.$$typeof) {
          case c:
            return Mt(i.render);
          case E:
            return se(i.type, o, f);
          case C: {
            var d = i, m = d._payload, y = d._init;
            try {
              return se(y(m), o, f);
            } catch {
            }
          }
        }
      return "";
    }
    var oe = Object.prototype.hasOwnProperty, qe = {}, Ye = G.ReactDebugCurrentFrame;
    function ue(i) {
      if (i) {
        var o = i._owner, f = se(i.type, i._source, o ? o.type : null);
        Ye.setExtraStackFrame(f);
      } else
        Ye.setExtraStackFrame(null);
    }
    function $t(i, o, f, d, m) {
      {
        var y = Function.call.bind(oe);
        for (var p in i)
          if (y(i, p)) {
            var v = void 0;
            try {
              if (typeof i[p] != "function") {
                var _ = Error((d || "React class") + ": " + f + " type `" + p + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof i[p] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw _.name = "Invariant Violation", _;
              }
              v = i[p](o, p, d, f, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (x) {
              v = x;
            }
            v && !(v instanceof Error) && (ue(m), k("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", d || "React class", f, p, typeof v), ue(null)), v instanceof Error && !(v.message in qe) && (qe[v.message] = !0, ue(m), k("Failed %s type: %s", f, v.message), ue(null));
          }
      }
    }
    var Wt = Array.isArray;
    function xe(i) {
      return Wt(i);
    }
    function Vt(i) {
      {
        var o = typeof Symbol == "function" && Symbol.toStringTag, f = o && i[Symbol.toStringTag] || i.constructor.name || "Object";
        return f;
      }
    }
    function Ut(i) {
      try {
        return Je(i), !1;
      } catch {
        return !0;
      }
    }
    function Je(i) {
      return "" + i;
    }
    function Xe(i) {
      if (Ut(i))
        return k("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", Vt(i)), Je(i);
    }
    var K = G.ReactCurrentOwner, Bt = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, Ze, Ke, we;
    we = {};
    function zt(i) {
      if (oe.call(i, "ref")) {
        var o = Object.getOwnPropertyDescriptor(i, "ref").get;
        if (o && o.isReactWarning)
          return !1;
      }
      return i.ref !== void 0;
    }
    function Gt(i) {
      if (oe.call(i, "key")) {
        var o = Object.getOwnPropertyDescriptor(i, "key").get;
        if (o && o.isReactWarning)
          return !1;
      }
      return i.key !== void 0;
    }
    function Ht(i, o) {
      if (typeof i.ref == "string" && K.current && o && K.current.stateNode !== o) {
        var f = L(K.current.type);
        we[f] || (k('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', L(K.current.type), i.ref), we[f] = !0);
      }
    }
    function qt(i, o) {
      {
        var f = function() {
          Ze || (Ze = !0, k("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
        };
        f.isReactWarning = !0, Object.defineProperty(i, "key", {
          get: f,
          configurable: !0
        });
      }
    }
    function Yt(i, o) {
      {
        var f = function() {
          Ke || (Ke = !0, k("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
        };
        f.isReactWarning = !0, Object.defineProperty(i, "ref", {
          get: f,
          configurable: !0
        });
      }
    }
    var Jt = function(i, o, f, d, m, y, p) {
      var v = {
        $$typeof: e,
        type: i,
        key: o,
        ref: f,
        props: p,
        _owner: y
      };
      return v._store = {}, Object.defineProperty(v._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(v, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: d
      }), Object.defineProperty(v, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: m
      }), Object.freeze && (Object.freeze(v.props), Object.freeze(v)), v;
    };
    function Xt(i, o, f, d, m) {
      {
        var y, p = {}, v = null, _ = null;
        f !== void 0 && (Xe(f), v = "" + f), Gt(o) && (Xe(o.key), v = "" + o.key), zt(o) && (_ = o.ref, Ht(o, m));
        for (y in o)
          oe.call(o, y) && !Bt.hasOwnProperty(y) && (p[y] = o[y]);
        if (i && i.defaultProps) {
          var x = i.defaultProps;
          for (y in x)
            p[y] === void 0 && (p[y] = x[y]);
        }
        if (v || _) {
          var w = typeof i == "function" ? i.displayName || i.name || "Unknown" : i;
          v && qt(p, w), _ && Yt(p, w);
        }
        return Jt(i, v, _, m, d, K.current, p);
      }
    }
    var be = G.ReactCurrentOwner, Qe = G.ReactDebugCurrentFrame;
    function H(i) {
      if (i) {
        var o = i._owner, f = se(i.type, i._source, o ? o.type : null);
        Qe.setExtraStackFrame(f);
      } else
        Qe.setExtraStackFrame(null);
    }
    var Ce;
    Ce = !1;
    function Re(i) {
      return typeof i == "object" && i !== null && i.$$typeof === e;
    }
    function et() {
      {
        if (be.current) {
          var i = L(be.current.type);
          if (i)
            return `

Check the render method of \`` + i + "`.";
        }
        return "";
      }
    }
    function Zt(i) {
      {
        if (i !== void 0) {
          var o = i.fileName.replace(/^.*[\\\/]/, ""), f = i.lineNumber;
          return `

Check your code at ` + o + ":" + f + ".";
        }
        return "";
      }
    }
    var tt = {};
    function Kt(i) {
      {
        var o = et();
        if (!o) {
          var f = typeof i == "string" ? i : i.displayName || i.name;
          f && (o = `

Check the top-level render call using <` + f + ">.");
        }
        return o;
      }
    }
    function rt(i, o) {
      {
        if (!i._store || i._store.validated || i.key != null)
          return;
        i._store.validated = !0;
        var f = Kt(o);
        if (tt[f])
          return;
        tt[f] = !0;
        var d = "";
        i && i._owner && i._owner !== be.current && (d = " It was passed a child from " + L(i._owner.type) + "."), H(i), k('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', f, d), H(null);
      }
    }
    function nt(i, o) {
      {
        if (typeof i != "object")
          return;
        if (xe(i))
          for (var f = 0; f < i.length; f++) {
            var d = i[f];
            Re(d) && rt(d, o);
          }
        else if (Re(i))
          i._store && (i._store.validated = !0);
        else if (i) {
          var m = St(i);
          if (typeof m == "function" && m !== i.entries)
            for (var y = m.call(i), p; !(p = y.next()).done; )
              Re(p.value) && rt(p.value, o);
        }
      }
    }
    function Qt(i) {
      {
        var o = i.type;
        if (o == null || typeof o == "string")
          return;
        var f;
        if (typeof o == "function")
          f = o.propTypes;
        else if (typeof o == "object" && (o.$$typeof === c || o.$$typeof === E))
          f = o.propTypes;
        else
          return;
        if (f) {
          var d = L(o);
          $t(f, i.props, "prop", d, i);
        } else if (o.PropTypes !== void 0 && !Ce) {
          Ce = !0;
          var m = L(o);
          k("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", m || "Unknown");
        }
        typeof o.getDefaultProps == "function" && !o.getDefaultProps.isReactClassApproved && k("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function er(i) {
      {
        for (var o = Object.keys(i.props), f = 0; f < o.length; f++) {
          var d = o[f];
          if (d !== "children" && d !== "key") {
            H(i), k("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", d), H(null);
            break;
          }
        }
        i.ref !== null && (H(i), k("Invalid attribute `ref` supplied to `React.Fragment`."), H(null));
      }
    }
    function it(i, o, f, d, m, y) {
      {
        var p = At(i);
        if (!p) {
          var v = "";
          (i === void 0 || typeof i == "object" && i !== null && Object.keys(i).length === 0) && (v += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var _ = Zt(m);
          _ ? v += _ : v += et();
          var x;
          i === null ? x = "null" : xe(i) ? x = "array" : i !== void 0 && i.$$typeof === e ? (x = "<" + (L(i.type) || "Unknown") + " />", v = " Did you accidentally export a JSX literal instead of a component?") : x = typeof i, k("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", x, v);
        }
        var w = Xt(i, o, f, m, y);
        if (w == null)
          return w;
        if (p) {
          var A = o.children;
          if (A !== void 0)
            if (d)
              if (xe(A)) {
                for (var q = 0; q < A.length; q++)
                  nt(A[q], i);
                Object.freeze && Object.freeze(A);
              } else
                k("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              nt(A, i);
        }
        return i === r ? er(w) : Qt(w), w;
      }
    }
    function tr(i, o, f) {
      return it(i, o, f, !0);
    }
    function rr(i, o, f) {
      return it(i, o, f, !1);
    }
    var nr = rr, ir = tr;
    te.Fragment = r, te.jsx = nr, te.jsxs = ir;
  }()), te;
}
(function(n) {
  process.env.NODE_ENV === "production" ? n.exports = Sr() : n.exports = kr();
})(Ae);
const T = Ae.exports.jsx, _r = Ae.exports.jsxs;
function Pr() {
  var s, u, l;
  const {
    mark: n
  } = bt(), {
    options: e,
    Mark: t
  } = j((c) => ({
    options: c.options,
    Mark: c.Mark
  }), !0);
  mr(n);
  const r = {
    label: n.label,
    value: n.value
  }, a = (l = (u = (s = e[n.childIndex]).initMark) == null ? void 0 : u.call(s, r)) != null ? l : r;
  return /* @__PURE__ */ T(t, {
    ...a
  });
}
class D {
  static get isSelectedPosition() {
    const e = window.getSelection();
    if (!!e)
      return e.isCollapsed;
  }
  static getCurrentPosition() {
    var e, t;
    return (t = (e = window.getSelection()) == null ? void 0 : e.anchorOffset) != null ? t : 0;
  }
  static getFocusedSpan() {
    var e, t, r;
    return (r = (t = (e = window.getSelection()) == null ? void 0 : e.anchorNode) == null ? void 0 : t.textContent) != null ? r : "";
  }
  static getSelectedNode() {
    var t;
    const e = (t = window.getSelection()) == null ? void 0 : t.anchorNode;
    if (e)
      return e;
    throw new Error("Anchor node of selection is not exists!");
  }
  static getAbsolutePosition() {
    var t, r, a;
    const e = (a = (t = window.getSelection()) == null ? void 0 : (r = t.getRangeAt(0)).getBoundingClientRect) == null ? void 0 : a.call(r);
    return e ? {
      left: e.left,
      top: e.top + e.height + 1
    } : {
      left: 0,
      top: 0
    };
  }
  static trySetIndex(e, t) {
    try {
      this.setIndex(e, t);
    } catch (r) {
      console.error(r);
    }
  }
  static setIndex(e, t) {
    const r = window.getSelection();
    if (!(r != null && r.anchorNode) || !r.rangeCount)
      return;
    const a = r.getRangeAt(0);
    a == null || a.setStart(e.firstChild || e, t), a == null || a.setEnd(e.firstChild || e, t);
  }
  static getCaretIndex(e) {
    let t = 0;
    const r = window.getSelection();
    if (!(r != null && r.rangeCount))
      return t;
    const a = r.getRangeAt(0), s = a.cloneRange();
    return s.selectNodeContents(e), s.setEnd(a.endContainer, a.endOffset), t = s.toString().length, t;
  }
  static setCaretToEnd(e) {
    if (!e)
      return;
    const t = window.getSelection();
    t == null || t.setPosition(e, 1);
  }
  static getIndex() {
    var t;
    const e = window.getSelection();
    return (t = e == null ? void 0 : e.anchorOffset) != null ? t : NaN;
  }
  static setIndex1(e) {
    const t = window.getSelection();
    if (!(t != null && t.anchorNode) || !t.rangeCount)
      return;
    const r = t.getRangeAt(0);
    r == null || r.setStart(r.startContainer.firstChild || r.startContainer, e), r == null || r.setEnd(r.startContainer.firstChild || r.startContainer, e);
  }
  setCaretRightTo(e, t) {
    const r = window.getSelection(), a = r == null ? void 0 : r.getRangeAt(0);
    a == null || a.setStart(a.endContainer, t), a == null || a.setEnd(a.endContainer, t);
  }
}
const Tr = () => {
  const n = ne(NaN);
  return lr(() => {
    Number.isNaN(n.current) || e();
  }), t;
  function e() {
    var a;
    const r = (a = window.getSelection()) == null ? void 0 : a.anchorNode;
    r && D.trySetIndex(r, n.current), n.current = NaN;
  }
  function t(r) {
    n.current = D.getCaretIndex(r);
  }
}, Or = () => {
  const n = bt(), { bus: e } = R(), { style: t, className: r, readOnly: a } = j((S) => ({
    readOnly: S.readOnly,
    style: S.spanStyle,
    className: S.spanClassName
  }), !0), s = Nr(n), [u, l] = re(n.mark.label), [c, h] = re(n.mark.value), g = X((S, N) => {
    N != null && N.silent || (l(S.label), h(S.value)), e.send(b.Change, { key: n.key, value: { ...S } });
  }, []), E = X(() => {
    l(""), h(void 0), e.send(b.Delete, { key: n.key });
  }, []), C = Tr();
  return { label: u, value: c, reg: s, onChange: g, onRemove: E, heldCaret: C, readOnly: a, style: t, className: r };
};
function Nr(n) {
  const e = ne(null);
  return X((t) => {
    if (t && "current" in t) {
      n.ref = t;
      return;
    }
    e.current = t, n.ref = e;
  }, []);
}
const Ar = () => {
  const {
    label: n,
    reg: e,
    onChange: t,
    heldCaret: r,
    className: a,
    style: s,
    readOnly: u
  } = Or();
  return /* @__PURE__ */ T("span", {
    ref: e,
    style: s,
    className: a,
    contentEditable: !u,
    suppressContentEditableWarning: !0,
    onInput: (c) => {
      var g;
      r(c.currentTarget);
      const h = (g = c.currentTarget.textContent) != null ? g : "";
      t({
        label: h
      }, {
        silent: !0
      });
    },
    onPaste: Dr,
    children: n
  });
};
function Dr(n) {
  n.preventDefault();
  const e = n.clipboardData.getData("text");
  document.execCommand("insertText", !1, e);
}
const Ct = mt(() => {
  const n = R(), {
    className: e,
    style: t,
    pieces: r
  } = j((s) => ({
    className: s.className ? ut + " " + s.className : ut,
    style: s.style,
    pieces: s.pieces
  }), !0), a = Oe(() => n.bus.events, []);
  return /* @__PURE__ */ T("div", {
    ref: n.containerRef,
    className: e,
    style: t,
    ...a,
    children: r.toArray().map((s) => /* @__PURE__ */ T(xr, {
      value: s,
      children: Et(s.mark) ? /* @__PURE__ */ T(Pr, {}) : /* @__PURE__ */ T(Ar, {})
    }, s.key))
  });
});
Ct.displayName = "MarkedText";
const Ir = () => {
  const {
    bus: n
  } = R(), e = j((a) => {
    var s;
    return (s = a.onContainer) != null ? s : {};
  }, !0), t = Object.keys(e), r = Object.values(e);
  I(() => {
    const a = [];
    for (let s = 0; s < t.length; s++) {
      let u = t[s], l = r[s];
      a.push(n.listen(u, l));
    }
    return () => a.forEach((s) => s());
  }, r);
};
function jr() {
  const n = R();
  O(b.Change, (e) => {
    const {
      pieces: t,
      onChange: r,
      options: a
    } = n.state, {
      key: s,
      value: u
    } = e, l = t.find((h) => h.key === s);
    l && u && (l.mark.label = u.label, l.mark.value = u.value);
    const c = t.toArray().map((h) => h.mark);
    r(ct(c, a));
  }, []), O(b.Delete, (e) => {
    const {
      pieces: t,
      onChange: r,
      options: a
    } = n.state, {
      key: s
    } = e, u = t.findNode((c) => c.key === s);
    u && u.remove();
    const l = t.toArray().map((c) => c.mark);
    r(ct(l, a));
  }, []), O(b.Select, (e) => {
    var E;
    const {
      pieces: t
    } = n.state, {
      value: r,
      trigger: {
        option: a,
        span: s,
        index: u,
        source: l
      }
    } = e, c = Ne(a.markup, r.label, r.value), h = wr(s, c, u, l), g = t.findNode((C) => C.mark.label === s);
    n.recovery = {
      caretPosition: 0,
      prevNodeData: (E = g == null ? void 0 : g.prev) == null ? void 0 : E.data,
      isPrevPrev: !0
    }, g && (g.data.mark.label = h, n.bus.send(b.Change, {
      value: {
        label: h
      },
      key: g.data.key
    }));
  }, []);
}
const Lr = () => {
  const n = R(), { value: e, options: t } = j((s) => ({ value: s.value, options: s.options }), !0), r = Oe(ve.split(e, t), [e, t]), a = ne(null);
  I(() => {
    const s = /* @__PURE__ */ new Set(), u = r.map((l) => {
      var g;
      let c = br(l, s);
      const h = (g = a.current) == null ? void 0 : g.findNode((E) => E.key === c);
      return !h || Mr(l, h) && c++ ? { key: c, mark: pe(l) ? l : { label: l } } : h.data;
    });
    a.current = $.from(u), n.setState({ pieces: a.current });
  }, [r.length]);
}, Mr = (n, e) => pe(n) ? !1 : e.data.mark.label !== n, Fr = (n) => {
  const e = R(), {
    children: t,
    ...r
  } = n;
  I(() => e.setState({
    options: xt(t)
  }), [t]), I(() => e.setState({
    ...r
  }));
}, $r = () => {
  const n = R();
  O("onFocus", (e) => n.focusedNode = n.state.pieces.findNode((t) => {
    var r;
    return ((r = t.ref) == null ? void 0 : r.current) === e.target;
  }), []), O("onBlur", (e) => n.focusedNode = void 0, []);
};
function z(n, e, t = []) {
  O("onKeyDown", (r) => {
    r.key === n && e(r);
  }, t);
}
function Wr() {
  const n = R();
  z(W.LEFT, (e) => {
    var a, s, u, l, c;
    if (!pt(e))
      return;
    const t = (a = n.focusedNode) == null ? void 0 : a.prev, r = (c = (s = t == null ? void 0 : t.data.ref) == null ? void 0 : s.current) != null ? c : (l = (u = t == null ? void 0 : t.prev) == null ? void 0 : u.data.ref) == null ? void 0 : l.current;
    r == null || r.focus(), D.setCaretToEnd(r), e.preventDefault();
  }), z(W.RIGHT, (e) => {
    var a, s, u, l, c;
    if (!gt(e))
      return;
    const t = (a = n.focusedNode) == null ? void 0 : a.next, r = (c = (s = t == null ? void 0 : t.data.ref) == null ? void 0 : s.current) != null ? c : (l = (u = t == null ? void 0 : t.next) == null ? void 0 : u.data.ref) == null ? void 0 : l.current;
    r == null || r.focus(), e.preventDefault();
  }), z(W.DELETE, (e) => {
    var a, s, u, l, c;
    if (!gt(e))
      return;
    const t = (a = n.focusedNode) == null ? void 0 : a.next;
    if (!(t != null && t.data.key))
      return;
    const r = (u = (s = t.prev) == null ? void 0 : s.data.mark.label.length) != null ? u : 0;
    n.recovery = {
      prevNodeData: (c = (l = t.prev) == null ? void 0 : l.prev) == null ? void 0 : c.data,
      caretPosition: r
    }, n.bus.send(b.Delete, {
      key: t.data.key
    }), e.preventDefault();
  }), z(W.BACKSPACE, (e) => {
    var a, s, u, l, c;
    if (!pt(e))
      return;
    const t = (a = n.focusedNode) == null ? void 0 : a.prev;
    if (!(t != null && t.data.key))
      return;
    const r = (u = (s = t.prev) == null ? void 0 : s.data.mark.label.length) != null ? u : 0;
    n.recovery = {
      prevNodeData: (c = (l = t.prev) == null ? void 0 : l.prev) == null ? void 0 : c.data,
      caretPosition: r
    }, n.bus.send(b.Delete, {
      key: t.data.key
    }), e.preventDefault();
  }), O("onKeyDown", (e) => {
    var t, r;
    if (e.ctrlKey && e.code === "KeyA") {
      e.preventDefault();
      const a = window.getSelection(), s = (t = n.containerRef.current) == null ? void 0 : t.firstChild, u = (r = n.containerRef.current) == null ? void 0 : r.lastChild;
      if (!a || !s || !u)
        return;
      a.setBaseAndExtent(s, 0, u, 1);
    }
  }, []);
}
function pt(n) {
  const e = n.target;
  return D.getCaretIndex(e) === 0;
}
function gt(n) {
  var r;
  const e = n.target;
  return D.getCaretIndex(e) === ((r = e.textContent) == null ? void 0 : r.length);
}
const Vr = () => {
  const n = j((e) => e.pieces);
  O("onClick", () => {
    var e, t, r, a;
    n.length === 1 && ((e = n.head) == null ? void 0 : e.data.mark.label) === "" && ((a = (r = (t = n.head) == null ? void 0 : t.data.ref) == null ? void 0 : r.current) == null || a.focus());
  }, [n]);
};
function Ur() {
  const {
    bus: n
  } = R(), e = X(() => n.send(b.CheckTrigger), []);
  O("onFocus", (t) => document.addEventListener("selectionchange", e), []), O("onBlur", (t) => document.removeEventListener("selectionchange", e), []);
}
class De {
  constructor() {
    P(this, "span");
    P(this, "node");
    P(this, "dividedText");
    let e = D.getCurrentPosition();
    this.node = D.getSelectedNode(), this.span = D.getFocusedSpan(), this.dividedText = this.getDividedTextBy(e);
  }
  static find(e) {
    if (D.isSelectedPosition)
      return new De().find(e);
  }
  getDividedTextBy(e) {
    return {
      left: this.span.slice(0, e),
      right: this.span.slice(e)
    };
  }
  find(e) {
    for (let t of e) {
      let r = this.matchInTextVia(t.trigger);
      if (r)
        return {
          value: r.word,
          source: r.annotation,
          index: r.index,
          span: this.span,
          node: this.node,
          option: t
        };
    }
  }
  matchInTextVia(e) {
    const t = this.matchRightPart(), r = this.matchLeftPart(e);
    if (r)
      return {
        word: r.word + t.word,
        annotation: r.annotation + t.word,
        index: r.index
      };
  }
  matchRightPart() {
    var t;
    const {
      right: e
    } = this.dividedText;
    return {
      word: (t = e.match(dr)) == null ? void 0 : t[0]
    };
  }
  matchLeftPart(e) {
    var l;
    const t = this.makeTriggerRegex(e), {
      left: r
    } = this.dividedText, a = r.match(t);
    if (!a)
      return;
    const [s, u] = a;
    return {
      word: u,
      annotation: s,
      index: (l = a.index) != null ? l : 0
    };
  }
  makeTriggerRegex(e) {
    const t = fe(e) + "(\\w*)$";
    return new RegExp(t);
  }
}
const Br = () => {
  const n = R();
  O(b.ClearTrigger, (e) => n.setState({
    trigger: void 0
  }), []), O(b.CheckTrigger, (e) => n.setState({
    trigger: De.find(n.state.options)
  }), []);
};
function zr() {
  const {
    bus: n
  } = R(), e = j((t) => t.trigger);
  I(() => {
    if (!e)
      return;
    const t = (r) => {
      r.key === W.ESC && n.send(b.ClearTrigger);
    };
    return window.addEventListener("keydown", t), () => window.removeEventListener("keydown", t);
  }, [e]);
}
function Gr() {
  const n = R(), e = j((t) => t.trigger);
  I(() => {
    if (!e)
      return;
    const t = (r) => {
      var s, u;
      let a = r.target;
      ((s = n.overlayRef.current) == null ? void 0 : s.contains(a)) || ((u = n.containerRef.current) == null ? void 0 : u.contains(a)) || n.bus.send(b.ClearTrigger);
    };
    return document.addEventListener("click", t), () => document.removeEventListener("click", t);
  }, [e]);
}
const Hr = () => {
  const n = R(), e = j((t) => t.pieces);
  I(() => {
    var t, r, a, s, u, l, c;
    if (n.recovery) {
      const {
        prevNodeData: h,
        caretPosition: g,
        isPrevPrev: E
      } = n.recovery, C = n.state.pieces.findNode((ge) => ge === h), S = E ? (u = (r = (t = C == null ? void 0 : C.next) == null ? void 0 : t.next) == null ? void 0 : r.next) != null ? u : (s = (a = n.state.pieces.head) == null ? void 0 : a.next) == null ? void 0 : s.next : (l = C == null ? void 0 : C.next) != null ? l : n.state.pieces.head, N = (c = S == null ? void 0 : S.data.ref) == null ? void 0 : c.current;
      N == null || N.focus(), N && D.trySetIndex(N, g), n.recovery = void 0;
    }
  }, [e]);
};
function qr() {
  const n = R(), e = ne(!1), t = ne(null);
  I(() => {
    const r = (a) => {
      t.current = a.target, e.current = !0;
    };
    return document.addEventListener("mousedown", r), () => document.removeEventListener("mousedown", r);
  }, []), I(() => {
    const r = (a) => {
      var c, h;
      const s = e.current, u = !((c = n.containerRef.current) != null && c.contains(t.current)) || t.current !== a.target, l = (h = window.getSelection()) == null ? void 0 : h.containsNode(n.containerRef.current, !0);
      s && u && l && n.setState({
        readOnly: !0
      });
    };
    return document.addEventListener("mousemove", r), () => document.removeEventListener("mousemove", r);
  }, []), I(() => {
    const r = () => {
      e.current = !1, t.current = null, n.setState({
        readOnly: !1
      });
    };
    return document.addEventListener("mouseup", r), () => document.removeEventListener("mouseup", r);
  }, []);
}
const Yr = ({
  props: n
}) => (Fr(n), Ir(), jr(), Lr(), $r(), Wr(), Vr(), Hr(), Br(), Ur(), zr(), Gr(), qr(), null), Jr = cr(({
  trigger: n,
  style: e,
  onSelect: t
}, r) => {
  const [a, s] = re(NaN), u = Oe(() => n.option.data.filter((c) => c.toLowerCase().indexOf(n.value.toLowerCase()) > -1), [n.value]), l = u.length;
  return z(W.UP, (c) => {
    c.preventDefault(), s((h) => isNaN(h) ? 0 : (l + (h - 1) % l) % l);
  }, [l]), z(W.DOWN, (c) => {
    c.preventDefault(), s((h) => isNaN(h) ? 0 : (h + 1) % l);
  }, [l]), z(W.ENTER, (c) => {
    c.preventDefault();
    const h = u[a];
    t({
      label: h,
      value: a.toString()
    });
  }, [u, a]), u.length ? /* @__PURE__ */ T("ul", {
    ref: r,
    className: "mk-suggestions",
    style: e,
    children: u.map((c, h) => {
      const g = h === a ? "mk-suggestion-active" : void 0;
      return /* @__PURE__ */ T("li", {
        ref: (E) => g && (E == null ? void 0 : E.scrollIntoView(!1)),
        className: g,
        onClick: (E) => t({
          label: c,
          value: h.toString()
        }),
        children: c
      }, c);
    })
  }) : null;
});
function Xr(n) {
  var u, l, c;
  const {
    bus: e
  } = R(), t = X(() => e.send(b.ClearTrigger), []), r = X((h) => {
    e.send(b.Select, {
      value: h,
      trigger: n
    }), e.send(b.ClearTrigger);
  }, [n]), a = D.getAbsolutePosition(), s = {
    trigger: n,
    style: a,
    onSelect: r,
    onClose: t
  };
  return (c = (l = (u = n.option).initOverlay) == null ? void 0 : l.call(u, s)) != null ? c : s;
}
const Zr = (n) => {
  const e = R(), t = Xr(n), r = j((a) => {
    var s;
    return (s = a.Overlay) != null ? s : Jr;
  });
  return /* @__PURE__ */ T(r, {
    ref: Cr(r) ? e.overlayRef : void 0,
    ...t
  });
}, Rt = mt(() => {
  const n = j((e) => e.trigger);
  return n ? /* @__PURE__ */ T(Zr, {
    ...n
  }, n.option.index) : null;
});
Rt.displayName = "Whisper";
var he, Y, J, de;
const Ie = class {
  constructor(...e) {
    Q(this, J);
    Q(this, he, /* @__PURE__ */ new Map());
    Q(this, Y, /* @__PURE__ */ new Map());
    e.forEach((t) => V(this, Y).set(t, /* @__PURE__ */ new Set()));
  }
  get events() {
    let e = {};
    for (let t of V(this, Y).keys())
      e[t] = (r) => this.send(t, r);
    return e;
  }
  static initWithExternalEvents(e) {
    return () => {
      const t = new Set(fr);
      return e && Object.keys(e).filter(dt).forEach((r) => t.add(r)), new Ie(...t);
    };
  }
  send(e, t) {
    le(this, J, de).call(this, e).forEach((r) => r(t));
  }
  listen(e, t) {
    return le(this, J, de).call(this, e).add(t), () => le(this, J, de).call(this, e).delete(t);
  }
};
let _e = Ie;
he = new WeakMap(), Y = new WeakMap(), J = new WeakSet(), de = function(e) {
  const t = dt(e) ? V(this, Y) : V(this, he);
  return t.has(e) || t.set(e, /* @__PURE__ */ new Set()), t.get(e);
};
var U;
const je = class {
  constructor(e, t) {
    Q(this, U, void 0);
    P(this, "focusedNode");
    P(this, "recovery");
    P(this, "containerRef", ot());
    P(this, "overlayRef", ot());
    this.bus = t, ke(this, U, e);
  }
  get state() {
    return V(this, U);
  }
  static create(e) {
    return () => {
      const { children: t, ...r } = e, a = {
        options: xt(t),
        pieces: hr,
        ...r
      }, s = _e.initWithExternalEvents(e.onContainer)();
      return new je(a, s);
    };
  }
  setState(e) {
    ke(this, U, { ...V(this, U), ...e }), this.bus.send(b.State, V(this, U));
  }
};
let Pe = je;
U = new WeakMap();
function Kr(n) {
  const [e] = re(Pe.create(n));
  return /* @__PURE__ */ _r(Er, {
    value: e,
    children: [/* @__PURE__ */ T(Ct, {}), /* @__PURE__ */ T(Rt, {}), /* @__PURE__ */ T(Yr, {
      props: n
    })]
  });
}
const rn = ({
  trigger: n = "@",
  markup: e = "@[__label__](__value__)",
  data: t = [],
  ...r
}) => null;
function nn(n, e, t) {
  const r = Array.isArray(e) ? {
    Mark: n,
    children: e
  } : {
    Mark: n,
    Overlay: e,
    children: t
  };
  return function(s) {
    const u = yt({}, s, r);
    return Kr(u);
  };
}
export {
  Kr as MarkedInput,
  rn as Option,
  Ne as annotate,
  nn as createMarkedInput,
  tn as denote,
  Or as useMark
};
//# sourceMappingURL=index.js.map
